Big Builder
===========

I personally don't want to be running CI/CD automation
with full access to my Docker socket.

I made this image to hold all my typical build toolset,
and also the gitea runner,
so now I can just say `runs-on: big-builder`,
and stuff works without docker.

This does mean I can't use github actions.
That's okay with me:
I don't want to be running node on my Raspberry Pi, either.
I know how to use the Bourne shell,
so I'm able to do everything I want that way.


How To Set This Up
------------------

1. Generate an example configuration, and edit it.
   Be sure to set tags here:
   I use something like `big-builder,go,python3,hugo`,
   and then I can say things like `requires: hugo` in my jobs.
2. Go get a runner registration token from your forgejo/gitea instance.
3. Run the interactive registation step.
4. Run the daemon.
5. Email me to let me know if these instructions worked for you!

```sh
mkdir /srv/big-builder
podman run --rm big-builder generate-config > /srv/big-builder/config.yaml # This generates a sample config
vim /srv/big-builder/config.yaml # Edit the config to your liking
podman run --rm -it -u 0:0 -v /srv/big-builder:/app big-builder register   # Tags here are overridden by config.yaml
podman run -d --restart=always -v /srv/big-builder:/app:ro big-builder daemon
```

Docker can be used instead of podman, with the same arguments.

More documentation is at
[gitea act runner](https://docs.gitea.com/usage/actions/act-runner).



Adding Other Packages
---------------------

Make your own image. Like so:

```Dockerfile
FROM git.woozle.org/neale/big-builder
RUN apt-get -y install nethack
```

Even better, steal this one's Containerfile and add stuff to it.
There's not much to it, and 
you shouldn't trust my image to be malware-free.


Caveats
-------

Right now (October 2023),
if anything tries to read from the tty,
the runner just sits there,
like POST BIOS patiently waiting for someone to press F1.
This is a problem with the runner that they might fix one day.
Just something to bear in mind:
I spent a bit of time chasing this one down.

I may have additional bugs/wishlist items open at
https://git.woozle.org/neale/big-builder/issues
